unit umain;

{$IFDEF FPC}
{$mode objfpc}{$H+}
{$ENDIF}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Buttons, StdCtrls, ExtCtrls,
  ComCtrls, Menus, Clipbrd,
  {$IFDEF FPC}
  LResources,
  {$ENDIF}
	libusb;

type
  Bytearray = array of byte;

  { TfMain }

  TfMain = class(TForm)
     btnRead: TButton;
     btnWrRd: TButton;
     btnRefresh: TButton;
     btnSend: TButton;
     cboSend: TComboBox;
     chkTimer: TCheckBox;
     edTimer: TEdit;
     Label1: TLabel;
     lbMsgWrRd: TLabel;
     lbTimer: TLabel;
     lbMsgR: TLabel;
     lbMsgS: TLabel;
     lstDev: TListBox;
     lstMsg: TListBox;
     mnClear: TMenuItem;
     mnCopyList: TMenuItem;
     pan: TPanel;
     Panel1: TPanel;
     Panel2: TPanel;
     popMsg: TPopupMenu;
     rgBulk: TRadioGroup;
     rgEP: TRadioGroup;
     Splitter1: TSplitter;
     tmrLese: TTimer;
     tvDev: TTreeView;
    procedure btnReadClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure btnWrRdClick(Sender: TObject);
    procedure chkTimerChange(Sender: TObject);
    procedure edTimerChange(Sender: TObject);
    procedure edTimerKeyPress(Sender: TObject; var Key: char);
    procedure FormCreate(Sender: TObject);
    procedure lstDevClick(Sender: TObject);
    procedure mnClearClick(Sender: TObject);
    procedure mnCopyListClick(Sender: TObject);
    procedure tmrLeseTimer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure Enumerate;
  end;

var
  fMain: TfMain;

implementation

{ TfMain }
{$IFNDEF FPC}
{$R *.dfm}
{$ENDIF}

procedure TfMain.FormCreate(Sender: TObject);
begin
  Enumerate;
end;

{$IFDEF FPC}
// FPC / Lazarus
procedure TfMain.lstDevClick(Sender: TObject);
Var it, it2, it2i: TTreeNode;
    ret, i: LongInt;
    s: String;
    Device : PUSBDevice;
    DeviceHandle: PUSBDevHandle;
    descriptor: TUSBDeviceDescriptor;
    config: PUSBConfigDescriptor;
    endpoint: PUSBEndpointDescriptor;
    str: Array [0..255] of Char;
    Procedure AddEP(tNode: TTreeNode; endpoint: TUSBEndpointDescriptor);
    Begin
      tvDev.Items.AddChild(tNode, 'bEndpointAddress: 0x' + IntToHex(endpoint.bEndpointAddress, 2));
      tvDev.Items.AddChild(tNode, 'bmAttributes: 0x' + IntToHex(endpoint.bmAttributes, 2));
      tvDev.Items.AddChild(tNode, 'wMaxPacketSize: ' + IntToStr(endpoint.wMaxPacketSize));
      tvDev.Items.AddChild(tNode, 'bInterval: ' + IntToStr(endpoint.bInterval));
      tvDev.Items.AddChild(tNode, 'bRefresh: ' + IntToStr(endpoint.bRefresh));
      tvDev.Items.AddChild(tNode, 'bSynchAddress: ' + IntToStr(endpoint.bSynchAddress));
    End;
    Procedure AddInterface(tNode: TTreeNode; iNr: LongInt; Intf: TUSBInterface);
    Var altsetting: PUSBInterfaceDescriptor;
        it2a: TTreeNode;
        m, n: LongInt;
    Begin
      altsetting := PUSBInterfaceDescriptor(Intf.altsetting);
      If Assigned(@Intf) And Assigned(altsetting) Then
      Begin
			it2i := tvDev.Items.AddChild(tNode, 'Interface: ' + IntToStr(iNr));
         For m := 0 To intf.num_altsetting - 1 Do
         Begin
            If m = 0 Then
               it2a := it2i
				Else it2a := tvDev.Items.AddChild(it2i, 'AltSetting: ' + IntToStr(m));
         	tvDev.Items.AddChild(it2a, 'bInterfaceNumber: ' + IntToStr(altsetting[m].bInterfaceNumber));
         	tvDev.Items.AddChild(it2a, 'bAlternateSetting: ' + IntToStr(altsetting[m].bAlternateSetting));
         	tvDev.Items.AddChild(it2a, 'bNumEndpoints: ' + IntToStr(altsetting[m].bNumEndpoints));
         	tvDev.Items.AddChild(it2a, 'bInterfaceClass: ' + IntToStr(altsetting[m].bInterfaceClass));
         	tvDev.Items.AddChild(it2a, 'bInterfaceSubClass: ' + IntToStr(altsetting[m].bInterfaceSubClass));
         	tvDev.Items.AddChild(it2a, 'bInterfaceProtocol: ' + IntToStr(altsetting[m].bInterfaceProtocol));
         	tvDev.Items.AddChild(it2a, 'iInterface: ' + IntToStr(altsetting[m].iInterface));
            endpoint := PUSBEndpointDescriptor(altsetting[m].endpoint);
            If Assigned(endpoint) Then
            Begin
               For n := 0 To altsetting[m].bNumEndpoints - 1 Do
                  AddEP(tvDev.Items.AddChild(it2a, 'Endpoint ' + IntToStr(n)), endpoint[n]);
            End;
         End;
      End;
    End;
    Procedure AddConfig(tNode: TTreeNode; Config: TUSBConfigDescriptor);
    Var k: LongInt;
        PIntf: PUSBInterface;
    Begin
      tvDev.Items.AddChild(tNode, 'wTotalLength: ' + IntToStr(Config.wTotalLength));
      tvDev.Items.AddChild(tNode, 'bNumInterfaces: ' + IntToStr(Config.bNumInterfaces));
      tvDev.Items.AddChild(tNode, 'bConfigurationValue: ' + IntToStr(Config.bConfigurationValue));
      tvDev.Items.AddChild(tNode, 'iConfiguration: ' + IntToStr(Config.iConfiguration));
      tvDev.Items.AddChild(tNode, 'bmAttributes: 0x' + IntToHex(Config.bmAttributes, 2));
      tvDev.Items.AddChild(tNode, 'MaxPower: ' + IntToStr(Config.MaxPower));
      PIntf := PUSBInterface(Config.intf);
      For k := 0 To Config.bNumInterfaces - 1 Do
         AddInterface(tNode, k, PIntf[k]);
    End;
    Procedure AddDescriptor(tNode: TTreeNode; DeviceDescriptor: TUSBDeviceDescriptor);
    Begin
      tvDev.Items.AddChild(tNode, 'bLength: ' + IntToStr(DeviceDescriptor.bLength));
      tvDev.Items.AddChild(tNode, 'bDescriptorType: ' + IntToStr(DeviceDescriptor.bDescriptorType));
      tvDev.Items.AddChild(tNode, 'bcdUSB: 0x' + IntToHex(DeviceDescriptor.bcdUSB, 4));
      tvDev.Items.AddChild(tNode, 'bDeviceClass: ' + IntToStr(DeviceDescriptor.bDeviceClass));
      tvDev.Items.AddChild(tNode, 'bDeviceSubClass: ' + IntToStr(DeviceDescriptor.bDeviceSubClass));
      tvDev.Items.AddChild(tNode, 'bDeviceProtocol: ' + IntToStr(DeviceDescriptor.bDeviceProtocol));
      tvDev.Items.AddChild(tNode, 'bMaxPacketSize0: ' + IntToStr(DeviceDescriptor.bMaxPacketSize0));
      tvDev.Items.AddChild(tNode, 'idVendor: 0x' + IntToHex(DeviceDescriptor.idVendor, 4));
      tvDev.Items.AddChild(tNode, 'idProduct: 0x' + IntToHex(DeviceDescriptor.idProduct, 4));
      tvDev.Items.AddChild(tNode, 'bcdDevice: 0x' + IntToHex(DeviceDescriptor.bcdDevice, 4));
      tvDev.Items.AddChild(tNode, 'iManufacturer: ' + IntToStr(DeviceDescriptor.iManufacturer));
      tvDev.Items.AddChild(tNode, 'iProduct: ' + IntToStr(DeviceDescriptor.iProduct));
      tvDev.Items.AddChild(tNode, 'iSerialNumber: ' + IntToStr(DeviceDescriptor.iSerialNumber));
      tvDev.Items.AddChild(tNode, 'bNumConfigurations: ' + IntToStr(DeviceDescriptor.bNumConfigurations));
    End;
    Procedure AddDevice(tNode: TTreeNode);
    Begin
      tvDev.Items.AddChild(tNode, 'next: 0x' + IntToHex(LongWord(Device^.next), 8));
      tvDev.Items.AddChild(tNode, 'prev: 0x' + IntToHex(LongWord(Device^.prev), 8));
      tvDev.Items.AddChild(tNode, 'filename: ' + Device^.filename);
      tvDev.Items.AddChild(tNode, 'bus: 0x' + IntToHex(LongWord(Device^.bus), 8));
      tvDev.Items.AddChild(tNode, 'descriptor: 0x' + IntToHex(LongWord(@Device^.descriptor), 8));
      tvDev.Items.AddChild(tNode, 'config: 0x' + IntToHex(LongWord(Device^.config), 8));
      tvDev.Items.AddChild(tNode, 'dev: 0x' + IntToHex(LongWord(Device^.dev), 8));
      tvDev.Items.AddChild(tNode, 'devnum: ' + IntToStr(Device^.devnum));
      tvDev.Items.AddChild(tNode, 'num_children: ' + IntToStr(Device^.num_children));
      tvDev.Items.AddChild(tNode, 'children: 0x' + IntToHex(LongWord(Device^.children), 8));
    End;
    Procedure AddDeviceHandle(tNode: TTreeNode; DeviceHandle: TUSBDevHandle);
    Begin
      tvDev.Items.AddChild(tNode, 'fd: ' + IntToStr(DeviceHandle.fd));
      tvDev.Items.AddChild(tNode, 'bus: 0x' + IntToHex(LongWord(DeviceHandle.bus), 8));
      tvDev.Items.AddChild(tNode, 'device: 0x' + IntToHex(LongWord(DeviceHandle.device), 8));
      tvDev.Items.AddChild(tNode, 'config: ' + IntToStr(DeviceHandle.config));
      tvDev.Items.AddChild(tNode, 'intf: ' + IntToStr(DeviceHandle.intf));
      tvDev.Items.AddChild(tNode, 'altsetting: ' + IntToStr(DeviceHandle.altsetting));
      tvDev.Items.AddChild(tNode, 'impl_info: 0x' + IntToHex(LongWord(DeviceHandle.impl_info), 8));
    End;
begin
   tvDev.Items.Clear;
  	If (lstDev.ItemIndex < 0) Then
    	Exit;
  	Device := PUSBDevice((lstDev.Items.Objects[lstDev.ItemIndex]));
   If Not Assigned(@Device^.descriptor) Then
      Exit;
   descriptor := TUSBDeviceDescriptor(Device^.descriptor);
   s := '';
  	DeviceHandle := usb_open(Device);
  	If Assigned(DeviceHandle) Then
   Begin
   	If descriptor.iManufacturer <> 0 Then
      Begin
         ret := usb_get_string_simple(DeviceHandle, descriptor.iManufacturer, str, Length(str));
         If (ret > 0) Then
            s := Trim(str) + ' - '
         Else s := '0x' + IntToHex(descriptor.idVendor, 4) + ' - ';
      End Else s := '0x' + IntToHex(descriptor.idVendor, 4) + ' - ';

   	If descriptor.iProduct <> 0 Then
      Begin
         ret := usb_get_string_simple(DeviceHandle, descriptor.iProduct, str, Length(str));
         If (ret > 0) And (Trim(str) <> '') Then
            s := s + Trim(str)
         Else s := s + '0x' + IntToHex(descriptor.idProduct, 4);
      End Else s := s + '0x' + IntToHex(descriptor.idProduct, 4);

      it := tvDev.Items.AddFirst(Nil, s);

   	If descriptor.iSerialNumber <> 0 Then
      Begin
         ret := usb_get_string_simple(DeviceHandle, descriptor.iSerialNumber, str, Length(str));
         If (ret > 0) And (Trim(str) <> '') Then
         Begin
         	s := 'Seriennummer: ' + Trim(str);
	      	tvDev.Items.AddChild(it, s);
         End;
      End;

      usb_set_configuration(DeviceHandle, 1);
      usb_claim_interface(DeviceHandle, 0);

   End Else Begin
      s := '0x' + IntToHex(descriptor.idVendor, 4) + ' - 0x' + IntToHex(descriptor.idProduct, 4);
	   it := tvDev.Items.AddChild(Nil, s);
   End;

	it2 := tvDev.Items.AddChild(it, 'DeviceHandle 0x' + IntToHex(LongWord(DeviceHandle), 8));
   AddDeviceHandle(it2, DeviceHandle^);
	it2 := tvDev.Items.AddChild(it, 'Device 0x' + IntToHex(LongWord(Device), 8));
   AddDevice(it2);
	it2 := tvDev.Items.AddChild(it, 'DeviceDescriptor 0x' + IntToHex(LongWord(@Device^.descriptor), 8));
   AddDescriptor(it2, Device^.descriptor);

   config := PUSBConfigDescriptor(Device^.config);
   If Assigned(config) Then
   Begin
   	For i := 0 To Device^.descriptor.bNumConfigurations - 1 Do
      Begin
         If Device^.descriptor.bNumConfigurations <= 1 Then
	   		it2 := tvDev.Items.AddChild(it, 'Configuration 0x' + IntToHex(LongWord(@config[i]), 8))
         Else it2 := tvDev.Items.AddChild(it, 'Configuration: ' + IntToStr(i) + ' 0x' + IntToHex(LongInt(@config[i]), 8));
         AddConfig(it2, config[i]);
      End;
   End;

  	If Assigned(DeviceHandle) Then
   Begin
      usb_release_interface(DeviceHandle, 0);
   	usb_close(DeviceHandle);
   End;
   tvDev.Items[0].Expand(True);
end;
{$ELSE}
// Delphi
procedure TfMain.lstDevClick(Sender: TObject);
Var it, it2, it2i: TTreeNode;
    ret, i: LongInt;
    s: String;
    Device : PUSBDevice;
    DeviceHandle: PUSBDevHandle;
    descriptor: TUSBDeviceDescriptor;
    config: array of PUSBConfigDescriptor;
	 endpoint: PUSBEndpointDescriptor;
    str: Array [0..255] of Char;
    Procedure AddEP(tNode: TTreeNode; endpoint: TUSBEndpointDescriptor);
	 Begin
      tvDev.Items.AddChild(tNode, 'bEndpointAddress: 0x' + IntToHex(endpoint.bEndpointAddress, 2));
      tvDev.Items.AddChild(tNode, 'bmAttributes: 0x' + IntToHex(endpoint.bmAttributes, 2));
      tvDev.Items.AddChild(tNode, 'wMaxPacketSize: ' + IntToStr(endpoint.wMaxPacketSize));
      tvDev.Items.AddChild(tNode, 'bInterval: ' + IntToStr(endpoint.bInterval));
      tvDev.Items.AddChild(tNode, 'bRefresh: ' + IntToStr(endpoint.bRefresh));
      tvDev.Items.AddChild(tNode, 'bSynchAddress: ' + IntToStr(endpoint.bSynchAddress));
    End;
    Procedure AddInterface(tNode: TTreeNode; iNr: LongInt; Intf: TUSBInterface);
	 Var altsetting: array Of PUSBInterfaceDescriptor;
		  it2a: TTreeNode;
		  m, n: LongInt;
	 Begin
		altsetting := @Intf.altsetting;
		If Assigned(@Intf) And Assigned(altsetting) Then
		Begin
			it2i := tvDev.Items.AddChild(tNode, 'Interface: ' + IntToStr(iNr));
			For m := 0 To intf.num_altsetting - 1 Do
			Begin
				If m = 0 Then
					it2a := it2i
				Else it2a := tvDev.Items.AddChild(it2i, 'AltSetting: ' + IntToStr(m));
				tvDev.Items.AddChild(it2a, 'bInterfaceNumber: ' + IntToStr(altsetting[m].bInterfaceNumber));
				tvDev.Items.AddChild(it2a, 'bAlternateSetting: ' + IntToStr(altsetting[m].bAlternateSetting));
				tvDev.Items.AddChild(it2a, 'bNumEndpoints: ' + IntToStr(altsetting[m].bNumEndpoints));
				tvDev.Items.AddChild(it2a, 'bInterfaceClass: ' + IntToStr(altsetting[m].bInterfaceClass));
				tvDev.Items.AddChild(it2a, 'bInterfaceSubClass: ' + IntToStr(altsetting[m].bInterfaceSubClass));
				tvDev.Items.AddChild(it2a, 'bInterfaceProtocol: ' + IntToStr(altsetting[m].bInterfaceProtocol));
				tvDev.Items.AddChild(it2a, 'iInterface: ' + IntToStr(altsetting[m].iInterface));

				For n := 0 To altsetting[m].bNumEndpoints - 1 Do
				Begin
					endpoint := Pointer(LongWord(altsetting[m].endpoint) + (LongWord(n) * Sizeof(TUSBEndpointDescriptor)));
					If Assigned(endpoint) Then
						AddEP(tvDev.Items.AddChild(it2a, 'Endpoint ' + IntToStr(n)), endpoint^);
				End;
			End;
      End;
    End;
    Procedure AddConfig(tNode: TTreeNode; Config: TUSBConfigDescriptor);
    Var k: LongInt;
		  PIntf: Array Of PUSBInterface;
    Begin
      tvDev.Items.AddChild(tNode, 'wTotalLength: ' + IntToStr(Config.wTotalLength));
		tvDev.Items.AddChild(tNode, 'bNumInterfaces: ' + IntToStr(Config.bNumInterfaces));
      tvDev.Items.AddChild(tNode, 'bConfigurationValue: ' + IntToStr(Config.bConfigurationValue));
      tvDev.Items.AddChild(tNode, 'iConfiguration: ' + IntToStr(Config.iConfiguration));
      tvDev.Items.AddChild(tNode, 'bmAttributes: 0x' + IntToHex(Config.bmAttributes, 2));
      tvDev.Items.AddChild(tNode, 'MaxPower: ' + IntToStr(Config.MaxPower));
		PIntf := @Config.intf;
      For k := 0 To Config.bNumInterfaces - 1 Do
			AddInterface(tNode, k, PIntf[k]^);
    End;
    Procedure AddDescriptor(tNode: TTreeNode; DeviceDescriptor: TUSBDeviceDescriptor);
    Begin
      tvDev.Items.AddChild(tNode, 'bLength: ' + IntToStr(DeviceDescriptor.bLength));
      tvDev.Items.AddChild(tNode, 'bDescriptorType: ' + IntToStr(DeviceDescriptor.bDescriptorType));
      tvDev.Items.AddChild(tNode, 'bcdUSB: 0x' + IntToHex(DeviceDescriptor.bcdUSB, 4));
      tvDev.Items.AddChild(tNode, 'bDeviceClass: ' + IntToStr(DeviceDescriptor.bDeviceClass));
      tvDev.Items.AddChild(tNode, 'bDeviceSubClass: ' + IntToStr(DeviceDescriptor.bDeviceSubClass));
      tvDev.Items.AddChild(tNode, 'bDeviceProtocol: ' + IntToStr(DeviceDescriptor.bDeviceProtocol));
      tvDev.Items.AddChild(tNode, 'bMaxPacketSize0: ' + IntToStr(DeviceDescriptor.bMaxPacketSize0));
      tvDev.Items.AddChild(tNode, 'idVendor: 0x' + IntToHex(DeviceDescriptor.idVendor, 4));
      tvDev.Items.AddChild(tNode, 'idProduct: 0x' + IntToHex(DeviceDescriptor.idProduct, 4));
      tvDev.Items.AddChild(tNode, 'bcdDevice: 0x' + IntToHex(DeviceDescriptor.bcdDevice, 4));
      tvDev.Items.AddChild(tNode, 'iManufacturer: ' + IntToStr(DeviceDescriptor.iManufacturer));
      tvDev.Items.AddChild(tNode, 'iProduct: ' + IntToStr(DeviceDescriptor.iProduct));
      tvDev.Items.AddChild(tNode, 'iSerialNumber: ' + IntToStr(DeviceDescriptor.iSerialNumber));
		tvDev.Items.AddChild(tNode, 'bNumConfigurations: ' + IntToStr(DeviceDescriptor.bNumConfigurations));
    End;
    Procedure AddDevice(tNode: TTreeNode);
    Begin
      tvDev.Items.AddChild(tNode, 'next: 0x' + IntToHex(LongWord(Device^.next), 8));
      tvDev.Items.AddChild(tNode, 'prev: 0x' + IntToHex(LongWord(Device^.prev), 8));
      tvDev.Items.AddChild(tNode, 'filename: ' + Device^.filename);
      tvDev.Items.AddChild(tNode, 'bus: 0x' + IntToHex(LongWord(Device^.bus), 8));
      tvDev.Items.AddChild(tNode, 'descriptor: 0x' + IntToHex(LongWord(@Device^.descriptor), 8));
		tvDev.Items.AddChild(tNode, 'config: 0x' + IntToHex(LongWord(Device^.config), 8));
      tvDev.Items.AddChild(tNode, 'dev: 0x' + IntToHex(LongWord(Device^.dev), 8));
      tvDev.Items.AddChild(tNode, 'devnum: ' + IntToStr(Device^.devnum));
      tvDev.Items.AddChild(tNode, 'num_children: ' + IntToStr(Device^.num_children));
      tvDev.Items.AddChild(tNode, 'children: 0x' + IntToHex(LongWord(Device^.children), 8));
    End;
    Procedure AddDeviceHandle(tNode: TTreeNode; DeviceHandle: TUSBDevHandle);
    Begin
      tvDev.Items.AddChild(tNode, 'fd: ' + IntToStr(DeviceHandle.fd));
      tvDev.Items.AddChild(tNode, 'bus: 0x' + IntToHex(LongWord(DeviceHandle.bus), 8));
      tvDev.Items.AddChild(tNode, 'device: 0x' + IntToHex(LongWord(DeviceHandle.device), 8));
      tvDev.Items.AddChild(tNode, 'config: ' + IntToStr(DeviceHandle.config));
      tvDev.Items.AddChild(tNode, 'intf: ' + IntToStr(DeviceHandle.intf));
      tvDev.Items.AddChild(tNode, 'altsetting: ' + IntToStr(DeviceHandle.altsetting));
      tvDev.Items.AddChild(tNode, 'impl_info: 0x' + IntToHex(LongWord(DeviceHandle.impl_info), 8));
    End;
begin
   tvDev.Items.Clear;
  	If (lstDev.ItemIndex < 0) Then
    	Exit;
  	Device := PUSBDevice((lstDev.Items.Objects[lstDev.ItemIndex]));
   If Not Assigned(@Device^.descriptor) Then
      Exit;
   descriptor := TUSBDeviceDescriptor(Device^.descriptor);
   s := '';
  	DeviceHandle := usb_open(Device);
  	If Assigned(DeviceHandle) Then
   Begin
   	If descriptor.iManufacturer <> 0 Then
      Begin
         ret := usb_get_string_simple(DeviceHandle, descriptor.iManufacturer, str, Length(str));
         If (ret > 0) Then
            s := Trim(str) + ' - '
         Else s := '0x' + IntToHex(descriptor.idVendor, 4) + ' - ';
      End Else s := '0x' + IntToHex(descriptor.idVendor, 4) + ' - ';

   	If descriptor.iProduct <> 0 Then
      Begin
         ret := usb_get_string_simple(DeviceHandle, descriptor.iProduct, str, Length(str));
         If (ret > 0) And (Trim(str) <> '') Then
            s := s + Trim(str)
         Else s := s + '0x' + IntToHex(descriptor.idProduct, 4);
      End Else s := s + '0x' + IntToHex(descriptor.idProduct, 4);

      it := tvDev.Items.AddFirst(Nil, s);

   	If descriptor.iSerialNumber <> 0 Then
      Begin
         ret := usb_get_string_simple(DeviceHandle, descriptor.iSerialNumber, str, Length(str));
         If (ret > 0) And (Trim(str) <> '') Then
         Begin
         	s := 'Seriennummer: ' + Trim(str);
	      	tvDev.Items.AddChild(it, s);
         End;
      End;

		usb_set_configuration(DeviceHandle, 1);
      usb_claim_interface(DeviceHandle, 0);

   End Else Begin
      s := '0x' + IntToHex(descriptor.idVendor, 4) + ' - 0x' + IntToHex(descriptor.idProduct, 4);
	   it := tvDev.Items.AddChild(Nil, s);
   End;

	it2 := tvDev.Items.AddChild(it, 'DeviceHandle 0x' + IntToHex(LongWord(DeviceHandle), 8));
   AddDeviceHandle(it2, DeviceHandle^);
	it2 := tvDev.Items.AddChild(it, 'Device 0x' + IntToHex(LongWord(Device), 8));
   AddDevice(it2);
	it2 := tvDev.Items.AddChild(it, 'DeviceDescriptor 0x' + IntToHex(LongWord(@Device^.descriptor), 8));
   AddDescriptor(it2, Device^.descriptor);

   config := @Device^.config;
   If Assigned(config) Then
   Begin
   	For i := 0 To Device^.descriptor.bNumConfigurations - 1 Do
      Begin
         If Device^.descriptor.bNumConfigurations <= 1 Then
				it2 := tvDev.Items.AddChild(it, 'Configuration 0x' + IntToHex(LongWord(@config[i]^), 8))
         Else it2 := tvDev.Items.AddChild(it, 'Configuration: ' + IntToStr(i) + ' 0x' + IntToHex(LongInt(@config[i]), 8));
         AddConfig(it2, config[i]^);
      End;
   End;

  	If Assigned(DeviceHandle) Then
   Begin
      usb_release_interface(DeviceHandle, 0);
   	usb_close(DeviceHandle);
   End;
   tvDev.Items[0].Expand(True);
end;
{$ENDIF}

procedure TfMain.mnClearClick(Sender: TObject);
begin
   lstMsg.Items.Clear;
end;

procedure TfMain.mnCopyListClick(Sender: TObject);
begin
   Clipboard.AsText := lstMsg.Items.Text;
end;

procedure TfMain.tmrLeseTimer(Sender: TObject);
begin
   btnReadClick(Nil);
end;

procedure TfMain.btnSendClick(Sender: TObject);
var
  i, res, iEP: LongInt;
  Device : PUSBDevice;
  DeviceHandle: PUSBDevHandle;
  txt: PChar;
  s: String;
begin
   // Merken Sende-Text in Liste
   i := cboSend.Items.IndexOf(cboSend.Text);
   If i > 0 Then
      cboSend.Items.Move(i, 0)
   Else If i < 0 Then
   Begin
      cboSend.Items.Add(cboSend.Text);
      While cboSend.Items.Count > 50 Do
      	cboSend.Items.Delete(50);
   End;

  	If (lstDev.ItemIndex < 0) Then
    	Exit;
  	Device := Pointer(lstDev.Items.Objects[lstDev.ItemIndex]);
  	DeviceHandle := usb_open(Device);
  	If Not Assigned(DeviceHandle) Then
  	Begin
      lbMsgS.Caption := 'Err DeviceHandle';
      Exit;
   End;

	If usb_set_configuration(DeviceHandle, 1) < 0 Then
   Begin
      lbMsgS.Caption := 'Err usb_set_configuration';
      lstMsg.Items.Insert(0, lbMsgS.Caption + ' ' + usb_strerror);
		usb_close(DeviceHandle);
      Exit;
   End;

	If usb_claim_interface(DeviceHandle, 0) < 0 Then
   Begin
      lbMsgS.Caption := 'Err usb_claim_interface';
      lstMsg.Items.Insert(0, lbMsgS.Caption + ' ' + usb_strerror);
		  	usb_close(DeviceHandle);
      Exit;
   End;
   //usb_set_altinterface(DeviceHandle^, 0);

   iEP := rgEP.ItemIndex;
   s := cboSend.Text;
   txt := PChar(s);
  	If (rgBulk.ItemIndex = 0) Then
	  	res := usb_bulk_write(DeviceHandle, iEP, txt, Length(s), 20)
  	Else res := usb_interrupt_write(DeviceHandle, iEP, txt, Length(s), 20);

	lbMsgS.Caption := 'Result: ' + IntToStr(res);
   If res < 0 Then
      lstMsg.Items.Insert(0, lbMsgS.Caption + ' ' + usb_strerror);

   usb_release_interface(DeviceHandle, 0);
 	usb_close(DeviceHandle);

end;

procedure TfMain.btnWrRdClick(Sender: TObject);
var
  i, res: LongInt;
  Device : PUSBDevice;
  DeviceHandle: PUSBDevHandle;
//  txt: PChar;
//  s: String;
begin
   // Merken Sende-Text in Liste
   i := cboSend.Items.IndexOf(cboSend.Text);
   If i > 0 Then
      cboSend.Items.Move(i, 0)
   Else If i < 0 Then
   Begin
      cboSend.Items.Add(cboSend.Text);
      While cboSend.Items.Count > 50 Do
      	cboSend.Items.Delete(50);
   End;
  	If (lstDev.ItemIndex < 0) Then
    	Exit;
  	Device := Pointer(lstDev.Items.Objects[lstDev.ItemIndex]);
  	DeviceHandle := usb_open(Device);
  	If Not Assigned(DeviceHandle) Then
  	Begin
      lbMsgS.Caption := 'Err DeviceHandle';
      Exit;
   End;

	If usb_set_configuration(DeviceHandle, 1) < 0 Then
   Begin
      lbMsgS.Caption := 'Err usb_set_configuration';
      lstMsg.Items.Insert(0, lbMsgS.Caption + ' ' + usb_strerror);
		usb_close(DeviceHandle);
      Exit;
   End;

	If usb_claim_interface(DeviceHandle, 0) < 0 Then
   Begin
      lbMsgS.Caption := 'Err usb_claim_interface';
      lstMsg.Items.Insert(0, lbMsgS.Caption + ' ' + usb_strerror);
		  	usb_close(DeviceHandle);
      Exit;
   End;
   //usb_set_altinterface(DeviceHandle^, 0);

//   iEP := rgEP.ItemIndex;
//   s := cboSend.Text;
//   txt := PChar(s);

//   res := usb_control_msg(DeviceHandle, USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, 0, 0, 0,@Controller, 1, 5000);

	lbMsgS.Caption := 'Result: ' + IntToStr(res);
   If res < 0 Then
      lstMsg.Items.Insert(0, lbMsgS.Caption + ' ' + usb_strerror);

   usb_release_interface(DeviceHandle, 0);
 	usb_close(DeviceHandle);
end;

procedure TfMain.chkTimerChange(Sender: TObject);
begin
   edTimer.Enabled := chkTimer.Checked;
   lbTimer.Enabled := chkTimer.Checked;
   btnRead.Enabled := Not chkTimer.Checked;
   tmrLese.Enabled := chkTimer.Checked;
end;

procedure TfMain.edTimerChange(Sender: TObject);
Var i: Integer;
begin
   If edTimer.Text = '' Then
   	tmrLese.Enabled := False
   Else Begin
      i := StrToIntDef(edTimer.Text, 0);
      tmrLese.Interval := Cardinal(i);
      tmrLese.Enabled := chkTimer.Checked And (i > 0);
   End;
end;

procedure TfMain.edTimerKeyPress(Sender: TObject; var Key: char);
begin
   If Not(Key In ['0'..'9', #8]) Then
      Key := #0;
end;

procedure TfMain.btnRefreshClick(Sender: TObject);
begin
   Enumerate;
end;

procedure TfMain.btnReadClick(Sender: TObject);
var
  res, iEP, iLen, iT: LongInt;
  Device : PUSBDevice;
  DeviceHandle: PUSBDevHandle;
  txt: Array[0..63] Of Char;
begin
  	If (lstDev.ItemIndex < 0) Then
    	Exit;
  	Device := Pointer(lstDev.Items.Objects[lstDev.ItemIndex]);
  	DeviceHandle := usb_open(Device);
  	If Assigned(DeviceHandle) Then
  	Begin

   	If usb_set_configuration(DeviceHandle, 1) < 0 Then
      Begin
         lbMsgR.Caption := 'Err usb_set_configuration';
         lstMsg.Items.Insert(0, lbMsgR.Caption + ' ' + usb_strerror);
   		usb_close(DeviceHandle);
         Exit;
      End;

   	If usb_claim_interface(DeviceHandle, 0) < 0 Then
      Begin
         lbMsgR.Caption := 'Err usb_claim_interface';
         lstMsg.Items.Insert(0, lbMsgR.Caption + ' ' + usb_strerror);
		  	usb_close(DeviceHandle);
         Exit;
      End;
      //usb_set_altinterface(DeviceHandle^, 0);

      iEP := rgEP.ItemIndex + $80;
      iLen := Length(txt);
      If Sender = Nil Then
      Begin
         iT := tmrLese.Interval - 1;
         If iT < 10 Then
            iT := 10;
         If iT > 100 Then
            iT := 100;
      End Else iT := 1000;
	  	If (rgBulk.ItemIndex = 0) Then
		  	res := usb_bulk_read(DeviceHandle, iEP, txt, iLen, iT)
	  	Else res := usb_interrupt_read(DeviceHandle, iEP, txt, iLen, iT);

      If res >= 0 Then
      	lstMsg.Items.Insert(0, 'RX: ' + TrimRight(txt));

  		lbMsgR.Caption := 'Result: ' + IntToStr(res);
      If res < 0 Then
         lstMsg.Items.Insert(0, lbMsgR.Caption + ' ' + usb_strerror);

      usb_release_interface(DeviceHandle, 0);
    	usb_close(DeviceHandle);
  	End Else lbMsgR.Caption := 'Err DeviceHandle';
end;

procedure TfMain.Enumerate;
var
  usb_bus: PUSBBus;
  dev:     PUSBDevice;
  ver:     PUSBVersion;
  i1, i2:  Integer;
begin
   i1 := usb_find_busses();
   i2 := usb_find_devices();
{$IFDEF WIN32}
   ver := usb_get_version();
   lstMsg.Items.Insert(0, Format('Version DLL: %d.%d.%d.%d  Driver: %d.%d.%d.%d  Find: %d/%d',
   	[ver^.dll.major, ver^.dll.minor, ver^.dll.micro, ver^.dll.nano,
    	 ver^.driver.major, ver^.driver.minor, ver^.driver.micro, ver^.driver.nano,
       i1, i2]));
{$ELSE}
   If LibUSBLoaded Then
	   lstMsg.Items.Insert(0, Format('LibUSB active  Find: %d/%d', [i1, i2]))
   Else lstMsg.Items.Insert(0, 'LibUSB NOT active!');
{$ENDIF}

   usb_bus := usb_get_busses();
   lstDev.Items.Clear;
   tvDev.Items.Clear;
   while Assigned(usb_bus) do
   begin
      dev := usb_bus^.devices;
      while Assigned(dev) do
      begin
       	lstDev.Items.AddObject(dev^.filename + '   ' + IntToStr(dev^.devnum),TObject(dev));
         dev := dev^.next;
      end;
      usb_bus := usb_bus^.next
   end;
   If lstDev.Items.Count > 0 Then
   	lstDev.ItemIndex := 0;
end;

initialization
  {$IFDEF FPC}
  {$I umain.lrs}
  {$ENDIF}

end.

